#include <TM1636.h>
#include <math.h>



//Definice jednotlivich pinu

#define keyD 9
#define keyU 10
#define keyM 11

#define led1 2
#define led2 3
#define led3 4
#define led4 5

#define temp 0
#define light 1

#define buzz 6

#define clk 7
#define data 8



unsigned long casovac = 0;      //casova konstatnta
unsigned int cas=30000;         //nastavitelny cas pro alarm po otevreni lednice

unsigned int lightTr=200;       //nastaveni hranice mezi svetlem a tmou

boolean f= false;               // promenna pro zobrazeni ve stupnich C nebo F

TM1636 dis = TM1636(clk,data);  //deklarace 
void setup() {
  // put your setup code here, to run once:

  Serial.begin(9600);           //inicializovani seriove linky

  //inicializace jednotlivych pinu
  pinMode(keyD, INPUT_PULLUP);
  pinMode(keyU, INPUT_PULLUP);
  pinMode(keyM, INPUT_PULLUP);
  pinMode(temp, INPUT);
  pinMode(light, INPUT);
  //inicializace a vycisteni displaye
  dis.init();
  dis.clearDisplay();
}


  //metoda pro zjisteni a spocteni teploty
int tep(){
  //zjisteni odporu rezistoru a spocteni teploty
    double Temp;
Temp = log(10000.0*((1024.0/analogRead(temp)-1))); 
 Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
 Temp = Temp - 273.15;  
 if(f) Temp = (Temp * 9.0)/ 5.0 + 32.0; 
 return (int)Temp;
  
  }

    //metoda pro zobrazeni teploty na displayi
  void zobTep(){
    
  int teplota = tep();    //ziskani teploty zavolanim metody
  if(teplota < 0){        //zjisteni zapornosti teploty


    //vypsani znamenka minus pri zaporne teplote
    dis.start();         
  dis.writeByte(ADDR_FIXED);
  dis.stop();           
  dis.start();          
  dis.writeByte(0x00|0xc0);       //-
  dis.writeByte(0x40);
  dis.stop();            
  dis.start();          
  dis.writeByte(0x88 + 2);
  dis.stop();   
  
    teplota = - teplota;  //odstraneni zapornosti pro bezchybne vypsani
}
 else dis.display(0x00,0x7F);   //vypsani prazdneho znaku pri kladne teplote

//vypsani teploty na jednotlive segmenty

//vypsani teploty na radu deseti
 if(teplota>9){                   
  dis.display(0x01,teplota/10);
 }else dis.display(0x01,0x7F);

          //vypsani zbytku
dis.display(0x02,teplota%10);

//vypsani znamenka C nebo F
if(f){                //pokud je nastavene vypsani ve F, vypiseme F
  dis.start();         
  dis.writeByte(ADDR_FIXED);
  dis.stop();           
  dis.start();          
  dis.writeByte(0x03|0xc0);         // F
  dis.writeByte(0x71);
  dis.stop();            
  dis.start();          
  dis.writeByte(0x88 + 2);
  dis.stop();
}
else{                   //pokud ne, vypiseme C
  dis.start();         
  dis.writeByte(ADDR_FIXED);
  dis.stop();           
  dis.start();          
  dis.writeByte(0x03|0xc0);       //C
  dis.writeByte(0x39);
  dis.stop();            
  dis.start();          
  dis.writeByte(0x88 + 2);
  dis.stop();
}
   
    
  }

  
void loop() {   //hlavni smycka






if(analogRead(light)>lightTr){  //cekani na otevreni lednice
  casovac = millis()+cas;         //zapsani casu otevreni lednice
  while(analogRead(light)>lightTr){ //smycka pri otevrene lednici
    
   //zjisteni stisku tlacitek
    if(!digitalRead(keyM)){         //pri stisknuti tlacitka M, zmena znamenka
      if(f)f = false;               
      else f = true;
      delay(150);                   //ochrana proti dvojtemu stisknuti pomodi cekaci smycky
    }

  zobTep();                   //volani metody pro zobrazeni teploty na displayi
  
  delay(50);                  //cekaci smycka pro plynulejsi zobrazovani teploty a proti stalemu zasilani dat na display
  
  if(millis()>casovac){       //zjisteni vyprseni casu pro otevreni
    
      tone(buzz,500);       //alarm
      delay(100);
      noTone(buzz);
      delay(100);
    
    }
  }

  //vypnuti displaye a alarmu po zavreni lednice
  noTone(buzz);   
  dis.clearDisplay();
}



}
